
var colour = c_white;
var font = font_battle_dialogue;


var sentence_x = 0;
var sentence_y = 0;


var line_spacing = 30;
var letter_spacing = 16;
if (Talker == "Papyrus") {
	line_spacing = 15;
	letter_spacing = 10;
}
if (Talker == "SansA" || Talker == "SansB") {
	line_spacing = 15;
	letter_spacing = 9;
}
if (Talker == "Gaster") {
	line_spacing = 15;
	letter_spacing = 13;
}
if (room != Room1 && room != Room2) {
	font = font_battle_dialogue;
	line_spacing /= 2;
	letter_spacing /= 2;
}
else {
	if Talker == "Normal" && instance_exists(obj_SpeechBubble) {
		font = font_battle_dialogue;
		line_spacing = 15;
		letter_spacing = 9;
	}
}


for (var i = 0; i < TextLength; i++) {
	
	if string_char_at(TextToDraw, i + 1) == "~" {
		if string_char_at(TextToDraw, i + 2) == "R"
			colour = c_red;
		if string_char_at(TextToDraw, i + 2) == "O"
			colour = c_orange;
		if string_char_at(TextToDraw, i + 2) == "Y"
			colour = c_yellow;
		if string_char_at(TextToDraw, i + 2) == "G"
			colour = c_lime;
		if string_char_at(TextToDraw, i + 2) == "A"
			colour = c_aqua;
		if string_char_at(TextToDraw, i + 2) == "B"
			colour = c_blue;
		if string_char_at(TextToDraw, i + 2) == "P"
			colour = c_fuchsia;
		if string_char_at(TextToDraw, i + 2) == "D"
			colour = DefaultColour;
		i += 2;
	}
	
	draw_set_color(colour);
	draw_set_font(font);
	
	
	if (string_char_at(TextToDraw, i + 1) == "&" && string_char_at(TextToDraw, i) != "}") {
		sentence_x = 0;
		sentence_y += line_spacing;
		i += 1;
	}
	
	
	if (string_char_at(TextToDraw, i + 1) == "@") {
		TextDelay = 2 * real(string_char_at(TextToDraw, i + 2));
		if (TextDelay < 2) {
			TextDelay = 2;
		}
		i += 2;
	}
	
	
	draw_text(x + sentence_x, y + sentence_y, string_char_at(TextToDraw, i + 1));
	sentence_x += letter_spacing;
}


if IsWriting {
	CurrentDelay += 1;
	if (CurrentDelay >= TextDelay) {
		CurrentDelay = 0;
		TextLength += 1;
		
		if (string_char_at(TextToDraw, TextLength) == "." || string_char_at(TextToDraw, TextLength) == "?" || string_char_at(TextToDraw, TextLength) == "!") {
			CurrentDelay = -30;
		}
		
		
		if (string_char_at(TextToDraw, TextLength) == ",") {
			CurrentDelay = -15;
		}
		
		
		if (TextLength >= string_length(TextToDraw)) {
			IsWriting = false;
		}
	}
	if (keyboard_check(ord("X")) || keyboard_check(ord("C"))) {
		TextLength = string_length(TextToDraw);
		IsWriting = false;
	}
}
else {
	
	if ((keyboard_check_pressed(ord("Z")) || keyboard_check(ord("C"))) && CanAdvance) {
		TextLength = 0;
		TextDelay = 2;
		CurrentDelay = 0;
		
		
		if variable_instance_exists(id, "TextQueue") {
			
			if (NumInQueue >= array_length(TextQueue)) {
				instance_destroy();
				exit;
			}
			TextToDraw = TextQueue[NumInQueue];
		}
		else {
			TextToDraw = "{end}";
		}
		
		IsWriting = true;
		if (TextToDraw == "" || TextToDraw == "{end}") {
			instance_destroy();
		}
		NumInQueue += 1;
	}
}